# ngx-material-window

[![Greenkeeper badge](https://badges.greenkeeper.io/zack9433/ngx-material-window.svg)](https://greenkeeper.io/)

## Consuming library

Install library

```bash
$ npm install @angular/material @angular/flex-layout @ngui/overlay ngx-material-window --save
```

and then from your Angular `AppModule`:

```typescript
import { BrowserModule } from '@angular/platform-browser';
import { NgModule } from '@angular/core';

import { AppComponent } from './app.component';

import { NgxMaterialWindowModule } from 'ngx-material-window';

@NgModule({
  declarations: [
    AppComponent
  ],
  imports: [
    BrowserModule,
    NgxMaterialWindowModule
  ],
  providers: [],
  bootstrap: [AppComponent]
})
export class AppModule { }
```

Once your library is imported, you can use its components, directives and pipes in your Angular application:

```xml
<!-- You can now use material window component in app.component.html -->
<ngx-md-window title="Ethernet">
  <ngx-md-window-state linkName="Information" stateName="info" icon="info">
    <h1>Hello</h1>
  </ngx-md-window-state>
  <ngx-md-window-state linkName="Setting" stateName="form" icon="settings">
    <h1>Form</h1>
  </ngx-md-window-state>
</ngx-md-window>
```

## Development

To generate all `*.js`, `*.d.ts` and `*.metadata.json` files:

```bash
$ npm run build
```

To lint all `*.ts` files:

```bash
$ npm run lint
```

## License

MIT © [Zack Yang](mailto:zack9433@gmail.com)
