module.exports = function(wallaby) {
  var compilerOptions = Object.assign(
    require('./tsconfig.json').compilerOptions,
    require('./src/tsconfig.spec.json').compilerOptions
  );

  return {
    files: ['src/tsconfig.spec.json', 'src/tsconfig.es5.json', 'src/*.ts', '!src/*.spec.ts'],

    tests: ['src/*.spec.ts'],

    env: {
      type: 'node',
      runner: 'node'
    },

    compilers: {
      '**/*.ts': wallaby.compilers.typeScript(compilerOptions)
    },

    testFramework: 'jest',
    setup: function() {
      const jestConfig = require('./package.json').jest;
      wallaby.testFramework.configure(jestConfig);
    },
    debug: true
  };
};
