(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/material'), require('@angular/common'), require('@angular/flex-layout'), require('@angular/core'), require('@ngui/overlay'), require('rxjs')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/material', '@angular/common', '@angular/flex-layout', '@angular/core', '@ngui/overlay', 'rxjs'], factory) :
	(factory((global['ngx-material-window'] = {}),global.ng.material,global.ng.common,global.ng.flexLayout,global.ng.core,global.ngOverlay,global.Rx));
}(this, (function (exports,material,common,index,core,index$1,rxjs) { 'use strict';

var NgxMaterialStateComponent = /** @class */ (function () {
    function NgxMaterialStateComponent() {
    }
    /**
     * @return {?}
     */
    NgxMaterialStateComponent.prototype.ngOnInit = function () {
        this.state = {
            name: this.stateName,
            linkName: this.linkName,
            icon: this.icon
        };
    };
    NgxMaterialStateComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'ngx-md-window-state',
                    template: "\n    <div *ngIf=\"state.isActive\">\n      <ng-content></ng-content>\n    </div>\n  "
                },] },
    ];
    /**
     * @nocollapse
     */
    NgxMaterialStateComponent.ctorParameters = function () { return []; };
    NgxMaterialStateComponent.propDecorators = {
        'linkName': [{ type: core.Input },],
        'stateName': [{ type: core.Input },],
        'icon': [{ type: core.Input },],
    };
    return NgxMaterialStateComponent;
}());

var NgxMaterialWindowService = /** @class */ (function () {
    function NgxMaterialWindowService() {
        this.overlaySubject = new rxjs.Subject();
    }
    /**
     * @param {?} cb
     * @return {?}
     */
    NgxMaterialWindowService.prototype.setOverlayFunction = function (cb) {
        this.showOverlay = cb;
    };
    /**
     * @return {?}
     */
    NgxMaterialWindowService.prototype.getOverlaySubject = function () {
        return this.overlaySubject;
    };
    NgxMaterialWindowService.decorators = [
        { type: core.Injectable },
    ];
    /**
     * @nocollapse
     */
    NgxMaterialWindowService.ctorParameters = function () { return []; };
    return NgxMaterialWindowService;
}());

var NgxMaterialWindowComponent = /** @class */ (function () {
    /**
     * @param {?} overlayManager
     * @param {?} windowService
     */
    function NgxMaterialWindowComponent(overlayManager, windowService) {
        this.overlayManager = overlayManager;
        this.windowService = windowService;
    }
    /**
     * @return {?}
     */
    NgxMaterialWindowComponent.prototype.ngOnInit = function () {
        this.overlayId = Math.random().toString();
        this.windowService.setOverlayFunction(this.showOverlay.bind(this));
    };
    /**
     * @return {?}
     */
    NgxMaterialWindowComponent.prototype.ngAfterContentInit = function () {
        var /** @type {?} */ click$ = rxjs.Observable.fromEvent(this.reloadBtn._getHostElement(), 'click');
        var /** @type {?} */ subject$ = this.windowService.getOverlaySubject();
        click$.subscribe(subject$);
        this.overlaySubject = subject$.subscribe(this.showOverlay.bind(this));
        this.stateComponents.forEach(function (cmp, index$$1) { return (cmp.state.isActive = index$$1 === 0 ? true : false); });
    };
    /**
     * @return {?}
     */
    NgxMaterialWindowComponent.prototype.ngOnDestroy = function () {
        this.overlaySubject.unsubscribe();
    };
    /**
     * @param {?} stateName
     * @return {?}
     */
    NgxMaterialWindowComponent.prototype.setActiveState = function (stateName) {
        this.stateComponents.forEach(function (cmp) { return (cmp.state.isActive = cmp.state.name === stateName ? true : false); });
    };
    /**
     * @param {?=} event
     * @return {?}
     */
    NgxMaterialWindowComponent.prototype.showOverlay = function (event) {
        this.spinnerWrap.nativeElement.style.height = this.card.nativeElement.offsetHeight + "px";
        this.overlayManager.open(this.overlayId, event);
    };
    NgxMaterialWindowComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'ngx-md-window',
                    template: "\n    <div class=\"ngx-md-window\" #card>\n      <md-card>\n        <div class=\"spinner-wrap\" #spinnerWrap>\n          <div [id]=\"overlayId\" ngui-overlay-position=\"top center\">\n            <md-spinner class=\"spinner\"></md-spinner>\n          </div>\n        </div>\n        <md-card-header fxLayout=\"row\" fxLayoutAlign=\"space-between\" class=\"ngx-md-window-header\">\n          <md-card-title style=\"margin-bottom: 0;\">\n            <h4 class=\"ngx-md-window-header-title\">{{ title }}</h4>\n          </md-card-title>\n          <div fxLayout=\"row\">\n            <button md-icon-button (click)=\"showOverlay($event)\" #reloadBtn>\n              <md-icon>replay</md-icon>\n            </button>\n            <div *ngIf=\"stateComponents.length > 0\">\n              <button\n                md-icon-button\n                [mdMenuTriggerFor]=\"menu\">\n                <md-icon>more_vert</md-icon>\n              </button>\n              <md-menu #menu=\"mdMenu\">\n                <button md-menu-item *ngFor=\"let cmp of stateComponents\" (click)=\"setActiveState(cmp.state.name)\">\n                  <md-icon *ngIf=\"cmp.state.icon\">{{ cmp.state.icon }}</md-icon>\n                  <span>{{ cmp.state.linkName }}</span>\n                </button>\n              </md-menu>\n            </div>\n          </div>\n        </md-card-header>\n        <md-card-content style=\"padding: 8px\">\n          <ng-content></ng-content>\n        </md-card-content>\n      </md-card>\n    </div>\n  ",
                    styles: [".spinner-wrap { position: absolute; top: 0; left: 0; width: 100%; z-index: 2; } .spinner { width: 35px; height: 35px; background-color: #fff; border: 5px solid #fff; border-radius: 50%; margin-top: 40px; } .ngx-md-window > md-card { padding: 0; } .ngx-md-window-header { color: rgba(0, 0, 0, 0.54); background-color: rgba(0, 0, 0, 0.03); } .ngx-md-window-header-title { margin-top: 10px; margin-bottom: 0; } "],
                    providers: [NgxMaterialWindowService]
                },] },
    ];
    /**
     * @nocollapse
     */
    NgxMaterialWindowComponent.ctorParameters = function () { return [
        { type: index$1.NguiOverlayManager, },
        { type: NgxMaterialWindowService, },
    ]; };
    NgxMaterialWindowComponent.propDecorators = {
        'title': [{ type: core.Input },],
        'stateComponents': [{ type: core.ContentChildren, args: [NgxMaterialStateComponent,] },],
        'card': [{ type: core.ViewChild, args: ['card',] },],
        'spinnerWrap': [{ type: core.ViewChild, args: ['spinnerWrap',] },],
        'reloadBtn': [{ type: core.ViewChild, args: ['reloadBtn',] },],
    };
    return NgxMaterialWindowComponent;
}());

var NgxMaterialWindowModule = /** @class */ (function () {
    function NgxMaterialWindowModule() {
    }
    NgxMaterialWindowModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        index.FlexLayoutModule,
                        material.MdCardModule,
                        material.MdIconModule,
                        material.MdMenuModule,
                        material.MdButtonModule,
                        material.MdProgressSpinnerModule,
                        index$1.NguiOverlayModule
                    ],
                    declarations: [
                        NgxMaterialWindowComponent,
                        NgxMaterialStateComponent
                    ],
                    exports: [
                        NgxMaterialWindowComponent,
                        NgxMaterialStateComponent
                    ]
                },] },
    ];
    /**
     * @nocollapse
     */
    NgxMaterialWindowModule.ctorParameters = function () { return []; };
    return NgxMaterialWindowModule;
}());

exports.NgxMaterialWindowModule = NgxMaterialWindowModule;
exports.NgxMaterialWindowComponent = NgxMaterialWindowComponent;
exports.NgxMaterialStateComponent = NgxMaterialStateComponent;
exports.NgxMaterialWindowService = NgxMaterialWindowService;

Object.defineProperty(exports, '__esModule', { value: true });

})));
